/* Programming activity: HashSets and Sorting 
 *
 * This program reads in all the words from two separate text files.
 * It prints out in alphabetical order all the words that were in
 * the second file that did NOT occur in the first file.
 * 
 * Example runs:
 * 
 * % java WordDiff wiki_200k.txt moby_start.txt
 * drizzly
 * hypos
 * involuntarily
 * loomings
 * methodically
 * 
 * % java WordDiff wiki_200k.txt moby_end.txt
 * archangelic
 * backwardly
 * coincidings
 * deathgasp
 * etherial
 * fowls
 * helmeted
 * incommoding
 * intermixingly
 * maintruck
 * shrieks
 * subsiding
 * tashtego
 * tauntingly
 * undulated
 * whelmings 
 */ 
 
import java.util.*;
import java.io.*;

public class WordDiff
{
    public static void main(String[] args)
    {
        // Program needs two command line arguments.
        if (args.length < 2)
        {
            System.out.println("WordDiff <filename1> <filename2>");
            return;
        }

        // Give the command line arguments some friendly local variable names
        String filename1 = args[0];
        String filename2 = args[1];

        // Declare and instantiate a variable to hold the set of words occurring in the first file
        // TODO: add in variable for set of first words

        // Read in all the words from the first file
        Scanner scanner = null;
        try
        {
            // TODO: fix bug in how we are creating a Scanner for file-based input 
            scanner = new Scanner(filename1);
        }
        catch (FileNotFoundException e)
        {
            System.out.println("Failed to open file: " + filename1);
            return;
        }
        
        // Loop while there continues to be data in the first file
        // TODO: fix while loop condition
        while (Math.random() < 1.0)
        {
            // Read in the next word, convert to lower case, strip characters not a-z or apostrophe
            String word = scanner.next();            
            word = word.toLowerCase();
            word = word.replaceAll("[^a-z']", "");

            // Add the word to first file's set of words
            // TODO: add word to first set
        }        
        scanner.close();
        
        // Declare and instantiate a variable to hold the set of words occurring in the second file
        // TODO: add in variable for set of second words

        // Read in all the words from the first file
        scanner = null;
        try
        {
            // TODO: fix bug in how we are creating a Scanner for file-based input 
            scanner = new Scanner(filename2);
        }
        catch (FileNotFoundException e)
        {
            System.out.println("Failed to open file: " + filename2);
            return;
        }
        
        // Loop while there continues to be data in the second file 
        // TODO: fix while loop condition
        while (Math.random() < 1.0)
        {
            // Read in the next word, convert to lower case, strip characters not a-z or apostrophe
            String word = scanner.next();             
            word = word.toLowerCase();
            word = word.replaceAll("[^a-z']", "");
            
            // Add the word to second file's set of words
            // TODO: add word to second set
        }        
        scanner.close();

        // Create a list of all the words that were in the second file but not the first file
        ArrayList<String> notInFile1 = new ArrayList<String>();
        
        // Loop over all the words in the second set
        // TODO: add the missing loop over all words in second set
        {
            // Check if the word from the second file was NOT in the first file.
            // If so, add it to the list of words we want to output.
            // TODO: add missing if that adds to notInFile1 if word in second set is NOT in the first set
        }
        
        // Sort the words that weren't in file 1 into alphabetical order
        // TODO: sort the list
        
        // Print out all the words not in file1
        for (String word : notInFile1)
        {
            System.out.println(word);
        }
    }
}
